\section{Scalar Types\label{sec:types:sclr}}

If we think of \Types\ as having ``shapes'', then we can think of
them as a sort of Russian Doll, with simpler \Types\ fitting
inside more complex \Types. The smallest \Types\ are
single, indivisible units. These \Types\ are often called
\glspl{scalar}.

When an actual \gls{scalar} \textit{value} is defined in a program,
you can also think of it as a function that doesn't take any inputs,
and always returns the same \textit{value}. In fact, the compiler even
treats them this way, and thinking of \textit{values} as functions
will be helpful as we continue through the progression of
\Types.

Examples of \Gls{scalar} \Types\ are things like an
\textit{Integer}, a \textit{Char}, and even a \textit{Bool}. Examples
of ``\Gls{scalar} Values'' that correspond to these \Types\ would
be the values $1182$, \textit{'a'}, and \texttt{True}.

In \gls{ghci}, we can use these \Gls{scalar} \textit{Values}
directly by running:

This will import a module with the code:

Each of these values is one of a well-defined set of possible
values. In some cases, all of the values of the set are known. For
example, \textit{Bool} has exactly two values: \texttt{True} and
\texttt{False}.

The \textit{Char} type will hold any \gls{codepoint}. There are
potentially several billion of these, but currently
\href{http://www.unicode.org/versions/Unicode10.0.0/}{only 136,690 are
  actually assigned} to meaningful characters, and this assigned set
changes fairly often.

And finally the \textit{Integer} \gls{type} will hold any positive,
negative, or zero-valued number that doesn't have a fraction, and that
your computer has memory for. This is still a well-defined set because
even without a fully known or fixed set of values, determining if a
number in as \textit{Integer} can be done with a simple test any
machine with enough storage and processing power can perform.

%%% Local Variables:
%%% mode: latex
%%% TeX-master: "../../../FunctionalWeb.tex"
%%% End:
